/* ---- (c) SETA DOMINIO PUBLICO ----- */
/* ---- LINUX X-WIN ---------------- */
/* ---- MODIFICADO 10-09-1999 -------- */
#include "stdio.h"
#include "stdlib.h"
#include "string.h" 
#include <sys/time.h> 

#include <X11/Xlib.h>
#include <X11/Xutil.h>

/* --- Rutinas bajo nivel --- */

void clear(unsigned char c);
void plot(int x,int y);
int point(int x,int y);
void line(int x,int y,int xx,int yy);
void bar(int x,int y,int xx,int yy);
void setfont(char *nombre);
void impri (int x,int y,unsigned char ca);
void paleta(void);
void paletapal(void);
void paletablock(int n);
void loadpcx(char *nombre);
void mode(int mode_code);
int dmode(void);
int inkey2(void);
int inkey(void);
void waits(int s);
void espera(int s);
unsigned int Ctime(void);
void velocidad(void);
void mouse(int x);
void mouses(int x,int y,int t);
void getblock(int n,int x,int y,unsigned int ancho,unsigned int alto);
void putblock(int n,int x,int y);
void loadblock(int n,char *nombre);
void putz(int n,long xd,long yd,long xs,long ys, long xx, long yy);
void getz(int n,long xd,long yd,long xs,long ys, long xx, long yy);
void getcolors(void);
void igetcolors(void);
void setcolor(void);
void fade(int num);


/* --- Rutinas normales --- */
void inputc(int x,int y,char *nombre);
long inputn(int x,int y,char *nombre);
void box(int x,int y,int xx,int yy);
void printc(int x,int y,char *texto);
void printn(int x,int y,long num);
void error(int z);
void Sbeep(unsigned short high);

unsigned char inportb(unsigned short port);
void outportb(unsigned short port, unsigned char value);
/* ---- Rutinas no implementadas ---- */
void sonido(unsigned int frecuencia,unsigned int duracion);

/* ---- rutinas Xwin ---- */
int xinkey(void);


/* ---------------------- */

unsigned char *pv,*pv1,*pvx;
unsigned int *pvi,*pvi1;
int INK,PAPER,SPEED,SETIM;
int XMOUSE,YMOUSE,KMOUSE,CMOUSE,IMOUSE=255,PMOUSE=4;
int MOUSE=1;
int FONTX=1,FONTY=2,FONTXX,FONTYY,CX,CY;
FILE *pf;
char VARI[80];
int *VARI0;
unsigned char tabla[2040],pal[800];
unsigned long COLOR[16];
unsigned long ICOLOR[256];
unsigned char tleta[48]= {0,0,0,63,63,63,
			  0,63,63,63,0,63,
			  0,0,63,63,63,0,
			  0,63,0,63,0,0,
			  32,32,32,47,47,47,
			  0,47,47,47,0,47,
			  0,0,47,47,47,0,
			  0,47,0,47,0,0
			  };
unsigned char *grafi[16];
unsigned char *grafip[16];

/* ----- X-WIN ----- */
    Window Miventana;
    Display *Midisplay; 
    int Mipantalla;
    XSetWindowAttributes Miattr;
    unsigned long Mimask = 0L;
    GC Migc;
    XGCValues Migcv;
    XColor Micolor;
    Colormap Mimapa;
    XEvent *Mievent;
    Font Mifont;
    char INKEY;
    int INKEY2;


/* ---- LEE CADENA DEL TECLADO ----*/
void inputc(int x,int y,char *nombre)
{
int z,zz,n;
	printc(x,y,nombre);
	pv=nombre;
	for(z=0;z<79;z++){ if(*pv==0)break;  pv++;} 
	x+=FONTXX*z; z=x; n=0; zz=0;
	while(zz!=10)
		{
		 zz=xinkey();
		 if(zz==13 || zz==27) goto fin;
		 if(zz!=0)
			{
			 if(zz==8)
			  { if(n!=0){z-=FONTXX;n--;impri(z,y,32);} }
			  else
			  { impri(z,y,zz); if(n<38){z+=FONTXX; VARI[n]=zz; n++;}}
			}
		}
fin:
	VARI[n]=0;
}

/* ---- LEE NUMERO DEL TECLADO ----*/
long inputn(int x,int y,char *nombre)
{
	inputc(x,y,nombre);
	return(atol(VARI));
}



/* -----Cambia la tinta y el papel en curso ---- */
void setcolor(void)
{
static unsigned char i,p;

	if(PAPER!=p || INK!=i)
		{
		 Migcv.foreground=ICOLOR[INK];
		 Migcv.background=ICOLOR[PAPER];
		 XChangeGC(Midisplay,Migc,GCForeground|GCBackground,&Migcv);
		 p=PAPER; i=INK;
		}
}
/*---- coloca paleta por defecto ----*/
void paleta()
{
 int z;

 	for(z=0;z<48;z++) pal[z]=tleta[z];
	igetcolors();
}

/* --- Coloca los colores definidos en pal en la cadena ICOLOR --- */
void igetcolors(void)
{
int x,z,zz;
unsigned int xr,xv,xa;
 for(x=0;x<256;x++)
	{
	 zz=x*3;
	 Micolor.red=pal[zz]<<10;
	 Micolor.green=pal[zz+1]<<10;
	 Micolor.blue=pal[zz+2]<<10;
	 XAllocColor(Midisplay,Mimapa,&Micolor);
	 ICOLOR[x]=Micolor.pixel;
	}
}
/* --- Coloca los colores definidos en tleta en la cadena COLOR --- */
void getcolors(void)
{
int x,z,zz;
unsigned int xr,xv,xa;
 for(x=0;x<16;x++)
	{
	 zz=x*3;
	 Micolor.red=tleta[zz]<<10;
	 Micolor.green=tleta[zz+1]<<10;
	 Micolor.blue=tleta[zz+2]<<10;
	 XAllocColor(Midisplay,Mimapa,&Micolor);
	 COLOR[x]=Micolor.pixel;
	}
}

/* ----- BORRA PANTALLA ---- */
void clear(unsigned char c)
{
static unsigned char cc=100;
	if(cc!=c)XSetWindowBackground(Midisplay,Miventana,ICOLOR[c]);
	XClearWindow(Midisplay,Miventana);
	cc=c;
}

/* ----- LEE TECLA ----- */
void do_KeyPress (void)
{
   XKeyEvent *e = (XKeyEvent *) Mievent;
   KeySym ks;
   char str[256+1];
   int z;
    z = XLookupString (e, str, 256, &ks, NULL);
    INKEY=str[0];
    INKEY2=e->keycode;
}
void do_KeyRelease (void)
{
    INKEY=0;
    INKEY2=0; 
} 

int inkey(void)
{
 return(INKEY);
 INKEY=0;
}
int inkey2(void)
{
 return(INKEY2);
 INKEY2=0;
}

/* ----- RUTINA DE LECTURA DE TECLA EN XWIN ------- */
int xinkey(void)
{
     XEvent event;
	XNextEvent (Midisplay, &event);
	Mievent=&event;
	switch (event.type)
         {
	  case KeyPress:
	    do_KeyPress ();
	    break;
	  case KeyRelease:
	    do_KeyRelease ();
	    break;
	  default:          
	    break;
	}
 return(inkey());
}
/* ------MOUSE ------ */
/*  3-(XMOUSE,YMOUSE) 4-KMOUSE */
void mouse(int x)
{
static int MX,MY,MK;
	if(x==3 || x==9)
	 {
	  	XMotionEvent *e = (XMotionEvent *) Mievent;
		XMOUSE = e->x;
		YMOUSE = e->y;
		CMOUSE=0;
	 }
	if(x==4)
	 {
		XButtonEvent *e = (XButtonEvent *) Mievent;
		KMOUSE = e->button;
		if(KMOUSE==1)KMOUSE=1;
		if(KMOUSE==3)KMOUSE=2;
		CMOUSE=0;
	 }
	if(x==5) {CMOUSE=0; KMOUSE=0;}
	if(MX!=XMOUSE || MY!=YMOUSE || MK!=KMOUSE) CMOUSE=1;
	MX=XMOUSE; MY=YMOUSE; MK=KMOUSE;
}

/* ---- devuelve tiempo del sistema ---- */
unsigned int Ctime(void)
{

struct timeval tv;
unsigned int z,zz;
	gettimeofday(&tv,NULL);
	z=tv.tv_usec/10000;
	zz=(tv.tv_sec & 0x00fff)*100;
	return(zz+z);
}

/* ---- espera un tiempo calculado en 25 cada segundo ---- */
void espera(int s)
{
int z;
	z=s*4;
	z+=(Ctime());
	if(z-Ctime()>250) goto fin;
 	while(Ctime()<z);
fin:
}
/* ----- IMPRIME LINEA ------------ */
void line(int x,int y,int xx,int yy)
{
	setcolor();
	XDrawLine (Midisplay,Miventana,Migc,x,y,xx,yy);
}

/* ----- IMPRIME UNA CADENA ------- */
void printc(int x,int y,char *texto)
{
	setcolor();
 	XDrawImageString (Midisplay,Miventana,Migc,x,y+FONTYY,texto,strlen(texto));
}
/* ---- IMPRIME NUMERO ----*/
void printn(int x,int y,long num)
{
int z;
 for(z=0;z<80;z++)VARI[z]=0;
 sprintf(VARI,"%d",num);
 printc(x,y,VARI);
}

/* -----IMPRIME CARACTER ---------- */

void impri (int x,int y,unsigned char ca)
{
	setcolor();
 	XDrawImageString (Midisplay,Miventana,Migc,x,y+FONTYY,&ca,1);
}

/* ------ Coloca caracter ----------- */
void setfont(char *nombre)
{
	if(0==strcmp(nombre,"8x16"))
		{
   		 Mifont=XLoadFont(Midisplay,"8x16");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=8;FONTYY=16;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"9x15"))
		{
   		 Mifont=XLoadFont(Midisplay,"9x15");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=9;FONTYY=15;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"6x10"))
		{
   		 Mifont=XLoadFont(Midisplay,"6x10");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=6;FONTYY=10;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"7x14"))
		{
   		 Mifont=XLoadFont(Midisplay,"7x14");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=7;FONTYY=14;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
salto:
   	 Mifont=XLoadFont(Midisplay,"8x*");
	 XSetFont(Midisplay,Migc,Mifont);
  	 FONTXX=8;FONTYY=16;
   	 FONTX=1;FONTY=2;
fin:
}

void mode(int mode_code)
{
    if(mode_code==0)
	{ XCloseDisplay(Midisplay); goto fin;}
    Midisplay = XOpenDisplay (NULL);
    if (!Midisplay)
     {	fprintf (stderr, "Imposible abrir display \n"); exit (1); }
    Mipantalla = DefaultScreen (Midisplay);
    Miattr.event_mask = KeyPressMask | KeyReleaseMask | ButtonPressMask |
			   ButtonReleaseMask | EnterWindowMask |
			   LeaveWindowMask | PointerMotionMask | 
			   Button1MotionMask |
			   Button2MotionMask | Button3MotionMask |
			   Button4MotionMask | Button5MotionMask |
			   ButtonMotionMask | KeymapStateMask |
			   ExposureMask | VisibilityChangeMask | 
			   StructureNotifyMask | /* ResizeRedirectMask | */
			   SubstructureNotifyMask | SubstructureRedirectMask |
			   FocusChangeMask | PropertyChangeMask |
			   ColormapChangeMask | OwnerGrabButtonMask;

    Miattr.background_pixel = WhitePixel(Midisplay,Mipantalla);
    Miattr.border_pixel = BlackPixel(Midisplay,Mipantalla);
    Mimask |= (CWBackPixel | CWBorderPixel | CWEventMask);
    switch(mode_code)
	{
	 case 10:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            640, 480,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
	  break;
	 case 13:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            320, 200,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
	  break;
	 default:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            320, 200,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
	}

    XSetStandardProperties(Midisplay,Miventana,VARI,"mini",None,NULL,0,NULL);
    XMapWindow (Midisplay, Miventana);
    espera(10);
    XFlush(Midisplay);
    Migc=DefaultGC(Midisplay,Mipantalla);
    Mimapa=DefaultColormap(Midisplay,Mipantalla);
    setfont("-");

fin:
}
/* ----- Imprime cuadrado ----- */
void box(int x,int y,int xx,int yy)
{
	setcolor();
	line(x,y,xx,y);
	line(xx,y,xx,yy);
	line(xx,yy,x,yy);
	line(x,yy,x,y);
}


/* ----- Imprime cuadrado relleno----- */
void bar(int x,int y,int xx,int yy)
{
int d;

	if(x>xx){d=x; x=xx; xx=d;}
  	if(y>yy){d=y; y=yy; yy=d;}
	setcolor();
	XFillRectangle(Midisplay,Miventana,Migc,x,y,xx-x,yy-y);
}





/* ------ Tratamiento de errores ----- */
void error(int z)
{
	switch(z)
		{
		 case 2:
			printc(0,0,"Fichero no encontrado");
			break;
		 case 8:
			printc(0,0,"Memoria insuficiente");
			break;
		 case 13:
			printc(0,0,"Dato invalido");
			break;
		 default:
			printc(0,0,"Error desconocido");
			break;
		}
}
